#include <windows.h>

#include <process.h>
#include <stdio.h>
#include <stdarg.h>

#include "disp.h"

#define	DELTA	10
#define	FONTDELTA	30

int bwid,bhig;
int dispsecond;
image*bmp0;

extern HANDLE _hInstance;

CRITICAL_SECTION cs;

HDC realdc,psmdc;
HWND w;
int disp_redraw(void) {
   InvalidateRect(w,0,0);
   return 1;
} /* disp_redraw */
int init_thread(void);
int disp_init(image*b0) {
   bmp0=b0;
   bhig=b0->ylen;
   bwid=b0->xlen;
   return init_thread();
} /* disp_init */
int disp_close(void) {
   SendMessage(w,WM_CLOSE,0,0);
   return 1;
} /* disp_close */

#define	KQMAX	16
int kl=0,kq[KQMAX],kqp;
int disp_key(void) {
   if(kl) {
      int k;
      EnterCriticalSection(&cs);
      k=kq[kqp]; kl--; kqp=(kqp+1)%KQMAX;
      LeaveCriticalSection(&cs);
      return k;
   } else return 0;
} /* disp_key */
#define	MAXEQL	2048
static int eql=0,eqp=0;
static ptrevent tpe,events[MAXEQL];
ptrevent* disp_ptrevent(void) {
   int i,p;
   for(i=0;i<5;i++) {
      if(eql) {
         EnterCriticalSection(&cs);
	 p=eqp%MAXEQL;
	 tpe=events[p];
	 eqp=(eqp+1)%MAXEQL; eql--;
         LeaveCriticalSection(&cs);
         return &tpe;
      } else Sleep(100);
   }
   return 0;
} /* disp_ptrevent */
static int regmove=0;
int disp_registermove(int flag) {
   int oldflag=regmove;
   regmove=flag;
   return oldflag;
} /* disp_registermove */

static char msgbuf[10000];

void disp_message(char*fmt,...) {
   va_list va;
   int i;
   if(!fmt) { msgbuf[0]=0;}
   va_start(va,fmt);
   vsprintf(msgbuf,fmt,va);
   for(i=0;msgbuf[i];i++) ;
   for(;i<3000;i++) msgbuf[i]=' ';
   msgbuf[i]=0;
   va_end(va);
} /* disp_message */

void disp_onlysecond(int flag) {
   dispsecond=flag!=0;
} /* disp_onlysecond */

typedef	struct	_bmphsubst	{
   BITMAPINFOHEADER h;
   DWORD rmask;
   DWORD gmask;
   DWORD bmask;
} bmphsubst;
bmphsubst defbmph={
   {
      sizeof(BITMAPINFOHEADER),	/* biSize */
      -1,			/* biWidth */
      -2,			/* biHeight */
      1,			/* biPlanes */
      32,			/* biBitCount */
      BI_RGB,		/* biCompression */
      0,			/* biSizeImage */
      0,			/* biXPelsPerMeter */
      0,			/* biYPelsPerMeter */
      0,			/* biClrUsed */
      0,			/* biClrImportant */
   },
   0x0000ff,
   0x00ff00,
   0xff0000,
};
static void copy_bmp(int n,image*bmp) {
//__emit__(0xcc);
   defbmph.h.biWidth=bmp->xlen;
   defbmph.h.biHeight=bmp->ylen;
   StretchDIBits(
      psmdc,
      n*(bmp0->xlen+DELTA)+DELTA,
      DELTA+bmp->ylen+FONTDELTA,
      bmp->xlen,
      -bmp->ylen,
      0,0,
      bmp->xlen,bmp->ylen,
      (VOID*)bmp->data,
      (BITMAPINFO*)&defbmph,
      DIB_RGB_COLORS,
      SRCCOPY
   );
GetLastError();
} /* copy_bmp */
static void copy_bitmaps(void) {
   copy_bmp(0,bmp0);
} /* copy_bitmaps */
static void show_msg(void) {
   int l;
   for(l=0;msgbuf[l];l++) ;
   if(!l) return;
   TextOut(
      psmdc,
      DELTA,DELTA,
      msgbuf,l
   );
} /* show_msg */
static void set_event(int x,int y) {
   int n=0,p;
   EnterCriticalSection(&cs);
   x-=DELTA; y-=DELTA+FONTDELTA;
   do {
      if(x<0 || y<0) break;
      if(!(x<bmp0->xlen && y<bmp0->ylen)) {
      } else break;
      if(eql>=MAXEQL) break;
      p=(eqp+eql)%MAXEQL;
      events[p].x=x; events[p].y=y; events[p].bmpn=n;
      eql++;
   } while(0);
   LeaveCriticalSection(&cs);
} /* set_event */
static LRESULT CALLBACK psm_wproc(HWND w,UINT msg,WPARAM wp,LPARAM lp) {
   PAINTSTRUCT ps;
   HBITMAP surf;
   int realx=bmp0->xlen+DELTA*2,
       realy=bmp0->ylen+DELTA*2;
   switch(msg) {
//    case WM_CREATE:
//      SetCursor(LoadCursor(_hInstance,IDC_ARROW));
//      break;
    case WM_CHAR:
      EnterCriticalSection(&cs);
      if(kl<KQMAX) {
         int i=(kqp+kl)%KQMAX;
         kq[i]=wp; kl++;
      }
      LeaveCriticalSection(&cs);
      return 0;
    case WM_LBUTTONUP:
      set_event(LOWORD(lp),HIWORD(lp));
      return 0;
    case WM_MOUSEMOVE:
       if(regmove) { set_event(LOWORD(lp),HIWORD(lp)); return 0;}
       else break;
    case WM_PAINT:
      BeginPaint(w,&ps);
      realdc=GetDC(w);
      psmdc=realdc;
      if(realdc) {
         copy_bitmaps();
         show_msg();
         BitBlt(realdc,0,0,realx,realy,psmdc,0,0,SRCCOPY);
         ReleaseDC(w,realdc);
      }
      EndPaint(w,&ps);
      return 0;
   }
   return DefWindowProc(w,msg,wp,lp);
} /* psm_wproc */


static int thflag;
static char classname[]="psm-class",
            windowname[]="psm-window";
static int init_window(void) {
   WNDCLASS wc;	/* Rather cute name */
   wc.style=CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc=psm_wproc;
   wc.cbClsExtra=0;
   wc.cbWndExtra=0;
   wc.hInstance=_hInstance;
   wc.hIcon=LoadIcon(0,IDI_APPLICATION);
   wc.hCursor=LoadCursor(0,IDC_ARROW);
   wc.hbrBackground=GetStockObject(BLACK_BRUSH);
   wc.lpszMenuName=0;
   wc.lpszClassName=classname;
   if(!RegisterClass(&wc)) return 0;
   w=CreateWindow(
      classname,
      windowname,
      WS_OVERLAPPEDWINDOW,
      0,
      0,
      (bmp0->xlen+DELTA)+DELTA+50,
      bmp0->ylen+DELTA*5+50,
      0,
      0,
      _hInstance,
      0
   );
   if(!w) return 0;
   return 1;
} /* init_window */
#pragma	argsused
static void thread(void*a) {
   int r=0;
   thflag=0;
   InitializeCriticalSection(&cs);
//{ char t[100]; GetModuleFileName(_hInstance,t,90); printf("My name is %s\n",t);}
   if(init_window()) {
      UpdateWindow(w);
      ShowWindow(w,SW_SHOWDEFAULT);
      r=thflag=1;
   } else thflag=-1;
   if(r) {
      MSG msg;
SetCapture(w);
      while(GetMessage(&msg,w,0,0)) {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      }
   }
   _endthread();
} /* thread */
static int init_thread(void) {
   int i;
   thflag=0;
   _beginthread(thread,65536,0);
   for(i=0;i<10000 && thflag==0;i++) Sleep(100);
   return thflag>0;
} /* init_thread */

