#ifndef	_hier_h
#define	_hier_h

#include <stdio.h>

#include "gr.h"

#include "vectypes.h"

#define	MAXSTOREDCOLORCOMP	255	/* one unsigned byte max value */
#define	COLORCOMPBITS	4	/* bits normally used per channel */
#define	MAXCOLORCOMP	((1<<COLORCOMPBITS)-1)
typedef	struct	_colorinfo	{
   unsigned char r,g,b;
} colorinfo;

#define	TRANSPBITS	7
#define	TRANSPONE	(1<<TRANSPBITS)
#define	TRANSPFULL	TRANSPONE
#define	TRANSPNONE	0
#define	TRANSPMUL(a,b)	(((longint)(a)*(longint)(b))>>TRANSPBITS)
typedef	unsigned char transpinfo;

#define	HFLAG_UPDATE	1
#define	HFLAG_FREE	2
#define	HFLAG_DELETED	4
typedef	struct	_hnode {
   struct _hnode *childs[N_SUBS];	/* child nodes */
   struct _hnode *parent;
   longint size;	/* side size */
   char flags;
   transpinfo transp[N_DIMS];
   colorinfo colors[N_DIMS*2];
} hnode;

/***************************************************************
 * Octree.
 */
extern hnode *world;	/* traversal root */

int  oct_init(longint maxside);
void oct_done(void);
int  oct_addatom(longint x,longint y,longint z,colorinfo *color,transpinfo transp);	/* Add atom-size cube */
void oct_update(void);	/* update the whole tree at once */
int  oct_optimize(void);	/* Concatenate voxels with equal characteristics */
void oct_dump();

void oct_mkctmul(fvec3 *viewdir,fvec3 *ctmul,ivec3 *sides);

int  oct_read(FILE*from);
int  oct_save(FILE*to);

/***************************************************************
 * Octree visualization through subdivision.
 */
void ov_subdivide(dvec3 *viewdir,long screenres);

#endif	/* _hier_h */
