#ifndef	_vmath_h
#define	_vmath_h

#include <math.h>

#define	_OP3(dest,src,op) { (dest)[0] op (src)[0]; (dest)[1] op (src)[1]; (dest)[2] op (src)[2]; }
#define	COPY3(dest,src) { _OP3(dest,src,=); }
#define	ADD3(dest,src) { _OP3(dest,src,+=); }
#define	SCALAR3(a,b) ((a)[0]*(b)[0]+(a)[1]*(b)[1]+(a)[2]*(b)[2])
#define	LEN3(a)	sqrt(SCALAR3(a,a))

#define	_DET2(a00,a01,a10,a11) ((a00)*(a11)-(a10)*(a01))
#define	CROSS3(a,b,dest) {			\
dest[0]=_DET2(a[1],a[2],b[1],b[2]);		\
dest[1]=_DET2(a[2],a[0],b[2],b[0]);		\
dest[2]=_DET2(a[0],a[1],b[0],b[1]);		\
}						/**/

#define	SCALE3(a,x)	{ (a)[0]*=x; (a)[1]*=x; (a)[2]*=x; }

#define	NORMALIZE3(a)	\
{ double x=1/LEN3((a)); SCALE3(a,x) }

#endif	/* _vmath_h */
